
$(function() {

	// Check the users browser can support both a webcam and html canvas
	var failedSupport = false;

	if ($('.browser-checks').length) {
		console.log('running browser checks');
		if ($('.browser-checks').attr('data-webcam') !== undefined) {
			var hasCamera = false;

			Webcam.on( 'load', function() {
		        // library is loaded
		    } );

			Webcam.on( 'error', function(err) {
		    	hasCamera = false;
		    } );

		}

		if ($('.browser-checks').attr('data-canvas') !== undefined) {
			if (Modernizr.canvas  === false) {
		      failedSupport = true;
		    }
		}


		if (failedSupport) {

			$('.browser-overlay').show();
		} else {

		}
	}


	if ($('#photoBox').length) {
		console.log('defined');

		var camWidth = 640;
		var camHeight = 480;
		if (screen.width < screen.height) {
			width = 480;
			height = 640;
		}

		Webcam.set({
			width: camWidth, // live preview size
		    height: camHeight,
		    dest_width: camWidth, // device capture size
		    dest_height: camHeight,
		    crop_width: 370, // final cropped size
		    crop_height: 370,
	        image_format: 'jpeg',
	        jpeg_quality: 100,
	        force_flash: false,
	        flip_horiz: true,
	        fps: 45
	    });

		Webcam.attach( '#photoBox' );

		$('.button-take-photo').on('click touchend', function(e) {
			e.preventDefault();
			Webcam.freeze();

			$('.photo-details').hide();
			$('.photo-container').addClass('col-sm-4').addClass('col-sm-offset-4');

			$(this).hide();

			$('.button-retake-photo').show();
			$('.button-use-photo').show();
			$('.photo-header').hide();
			$('.photo-confirm-header').show();
		});

		$('.button-retake-photo').on('click touchend', function(e) {
			e.preventDefault();
			$(this).hide();
			$('.button-take-photo').show();
			$('.button-use-photo').hide();

			$('.photo-header').show();
			$('.photo-confirm-header').hide();

			$('.photo-container').removeClass('col-sm-4').removeClass('col-sm-offset-4');
			$('.photo-details').show();

			Webcam.unfreeze();
		});

		$('.button-use-photo').on('click touchend', function(e) {
			e.preventDefault();

			Webcam.snap(function (data_uri) {

				var raw_image_data = data_uri.replace(/^data\:image\/\w+\;base64\,/, '');

				$('.photofield').val(raw_image_data);

				$('form.photoform').submit();
				// Webcam.upload(data_uri, '', function (code, text) {
				//
				// });
			});
		});
	}

	if ($('form.signatureform').length) {
		console.log('test');
		var canvas = document.querySelector("canvas");

		var signaturePad = new SignaturePad(canvas);

		function resizeCanvas() {
			// When zoomed out to less than 100%, for some very strange reason,
			// some browsers report devicePixelRatio as less than 1
			// and only part of the canvas is cleared then.
			var ratio =  Math.max(window.devicePixelRatio || 1, 1);
			canvas.width = canvas.offsetWidth * ratio;
			canvas.height = canvas.offsetHeight * ratio;
			canvas.getContext("2d").scale(ratio, ratio);
		}

		//signaturePad.minWidth = 300;
		//signaturePad.maxWidth = 770;

		window.onresize = resizeCanvas;
		resizeCanvas();

		$('.confirm-btn').on('click touchend', function(e) {
			e.preventDefault();

			var signature = signaturePad.toDataURL('image/jpeg');
			var raw_image_data = signature.replace(/^data\:image\/\w+\;base64\,/, '');

			$('input.signature').val(raw_image_data);

			$('form.signatureform').submit();

		});

	}
});

$(window).load(function() {

	resizeCanvas();
});
